import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;

public class DynamicIconText{
	public static void main(String[] args) {
		final JSlider width = new JSlider(JSlider.HORIZONTAL, 5, 150, 125);
		final JSlider height = new JSlider(JSlider.VERTICAL, 5, 150, 125);

		class DynamicIcon implements Icon {
			public int getIconWidth() {
				return width.getValue();
			}

			public int getIconHeight(){
				return height.getValue();
			}

			public void paintIcon(Component c, Graphics g, int x, int y) {
				g.fill3DRect(x, y, getIconWidth(), getIconHeight(), true);
			}
		}
		
		Icon icon = new DynamicIcon();
		final JLabel jl = new JLabel(icon);

		class Updater implements ChangeListener {
			public void stateChanged(ChangeEvent e) {
				jl.repaint();
			}
		};

		Updater ud = new Updater();
		width.addChangeListener(ud);
		height.addChangeListener(ud);
		JFrame fm = new JFrame();
		fm.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container ca = fm.getContentPane();
		ca.setLayout(new BorderLayout());
		ca.add(width, BorderLayout.NORTH);
		ca.add(height, BorderLayout.WEST);
		ca.add(jl, BorderLayout.CENTER);
		fm.setSize(250,250);
		fm.setVisible(true);
	}
}